#!/usr/bin/env python2
# -*- encoding=utf-8 -*-


import sys
from dueros.Bot import Bot
from dueros.directive.Display.RenderTemplate import RenderTemplate
from dueros.directive.Display.template.BodyTemplate1 import BodyTemplate1
import dueros.paho.mqtt.client as mqtt
reload(sys)
sys.setdefaultencoding('utf8')

class Test(Bot):

    def __init__(self, request_data):
        super(Test, self).__init__(request_data)
        self.add_launch_handler(self.launch_request)
        self.add_session_ended_handler(self.ended_request)

    def launch_request(self):
        """
        打开调用名
        """

        self.wait_answer()
        template = BodyTemplate1()
        template.set_title('控制台灯')
        template.set_plain_text_content('为您打开台灯')
        template.set_background_image('https://mc.dfrobot.com.cn/data/attachment/forum/202004/03/220658jy93iiy9b89p9a8i.jpg')
        template.set_token('0c71de96-15d2-4e79-b97e-e52cec25c254')
        renderTemplate = RenderTemplate(template)
        on_publish("12IZ3JpWR", "1", 0)#0代表保存在服务器上
        return {
            'directives': [renderTemplate],
            'outputSpeech': r'为您打开台灯'
        }
    def ended_request(self):
        """
        关闭调用名
        """
        self.wait_answer()
        template = BodyTemplate1()
        template.set_title('控制台灯')
        template.set_plain_text_content('为您关闭台灯')
        template.set_background_image('https://mc.dfrobot.com.cn/data/attachment/forum/202004/03/220658jy93iiy9b89p9a8i.jpg')
        template.set_token('0c71de96-15d2-4e79-b97e-e52cec25c254')
        renderTemplate = RenderTemplate(template)
        on_publish("12IZ3JpWR", "0", 0)#0代表保存在服务器上
        return {
            'directives': [renderTemplate],
            'outputSpeech': r'为您关闭台灯'
        }    
   

MQTTHOST = "182.254.130.180"
MQTTPORT = 1883
mqttClient = mqtt.Client()
  
  
# 连接MQTT服务器
def on_mqtt_connect():
    mqttClient.connect(MQTTHOST, MQTTPORT, 60)
    mqttClient.loop_start()
  
  
# publish 消息
def on_publish(topic, payload, qos):
    mqttClient.publish(topic, payload, qos)
    #print(topic)
  
# 消息处理函数
def on_message_come(lient, userdata, msg):
  
    print(msg.topic + " " + ":" + str(msg.payload))
  
  
# subscribe 消息
def on_subscribe():
    mqttClient.subscribe("E1RcL1tZg", 1)
    mqttClient.on_message = on_message_come # 消息到来处理函数

def handler(event, context):
    on_mqtt_connect()
    #on_publish("12IZ3JpWR", "Hello MQTT!", 0)#0代表保存在服务器上
    on_subscribe()
    bot = Test(event)
    result = bot.run()
    return result
